#include <iostream>
#include <thread>
#include <unistd.h>
#include <signal.h>
#include <string>
#include <cstdlib>

using namespace std;

int n = 10;

double fib(int n) {
  if (n < 2) return 1;
  return fib(n - 1) + fib(n - 2);
}

void f(string val, int num) {
  cout << "[" << val << "] ----" << "\n";
  cout << "[" << val << "] num: " << num << "\n";
  cout << "[" << val << "] Thread id: " << this_thread::get_id() << "\n";
  if (num == 1) {
    std::thread t2(f, "t2", 0);
    std::thread t3(f, "t3", 0);
    t2.join();
    t3.join();
  }
  sleep(1);
  cout << "[" << val << "] " << n << "\n";
  n--;
  cout << "[" << val << "] ----" << "\n";
}

int main(int argc, char * argv[]) {
  {
  cout << "main thread id: " << this_thread::get_id() << "\n";
  std::thread t1(f, "t1", 1); // add args to function here
  cout << "t1 id: " << t1.get_id() << "\n";
  cout << "Done." << "\n";

  t1.detach();
  cout << n << "\n";
  }
  sleep(3);
  
  return 0;
}
