#include <iostream>
#include <thread>
#include "Bank.h"

using namespace std;

// withdraw $1M in lots of small transactions
void run(BankAccount* b) {
    for (int i = 0; i < 100'000; i++) { b->withdraw(10); }
}

int main() {
    auto account = new BankAccount(2'000'000);
    thread t1(run, account);
    thread t2(run, account);
    t1.join();
    t2.join();
    cout << "---" << endl;
    cout << account->getBalance() << endl;
    return 0;
}
